#include<stdio.h>

int suma_znamenki(int broj){
    int suma = 0;
    if(broj < 0)
        broj = -broj;
    while(broj > 0){
        suma = suma + broj % 10;
        broj = broj / 10;
    }
    return suma;
}

int del_maxsum(int niz[], int n){
    int i, maks, maksi;

    /* inicijaliziramo najveci (i njegov indeks)
       na prvi element niza */
    maks = suma_znamenki(niz[0]);
    maksi = 0;

    /* trazimo ima li u ostatku niza element
       s vecom sumom znamenki */
    for(i = 1; i < n; ++i){
        int suma = suma_znamenki(niz[i]);
        if(suma > maks){
            maks = suma;
            maksi = i;
        }
    }

    /* uklanjamo maksi-ti element iz niza niz */
    for(i = maksi; i < n - 1; ++i)
        niz[i] = niz[i + 1];

    return n - 1; /* imamo 1 manje u nizu */
}

int main(void){
    int n = 10;
    int niz[10] = {34,-234,1023,-97,0,12,-5,45,-65,101};

    int i;
    printf("Niz prije poziva funkcije: ");
    for(i = 0; i < n; ++i)
        printf("%d ", niz[i]);

    n = del_maxsum(niz, n);
    printf("\nNiz nakon poziva funkcije: ");
    for(i = 0; i < n; ++i)
        printf("%d ", niz[i]);

    return 0;
}
