#include<stdio.h>

int JedanPotez(char A[], int n, char p, int k){
    /* trazimo polozaj figure s ozakom p */
    int i;
    for(i = 0; i < n; ++i)
        if(A[i] == p)
            break;

    /* pomicemo figuru s pozicije i na i + k */
    A[i] = '*';
    if(i + k >= n){ /* premasili duljinu - na zadnje mjesto */
        A[n - 1] = p;
        return n - 1;
    }

    /* inace figura ide na mjesto i + k */
    if(A[i + k] != '*') /* figuru koja vec tamo na pocetak ploce */
        A[0] = A[i + k];

    A[i + k] = p;

    return i + k; /* nova pozicija figure je sad i + k */
}

int JedanCiklus(char A[], int K[], int n, int nK, char *p){
    int br_poteza;
    char na_redu = *p;
    for(br_poteza = 0; br_poteza < nK; br_poteza++){
        if(JedanPotez(A,n,na_redu,K[br_poteza]) == n - 1){
            *p = na_redu; /* tko je pobijedio */
            return br_poteza + 1; /* npr. 0 + 1, tj. nakon 1 poteza */
        }
        /* odredimo tko je sljedeci na redu */
        na_redu = (na_redu == 'c') ? 'b' : 'c';
    }

    /* ako igra nije vec zavrsila: */
    *p = '*';
    return -1;
}

int main(void){
    int n = 20, nK = 10;
    char A[20] = {'*','*','b','*','c','*','*','*','*','*',
                  '*','*','*','*','*','*','*','*','*','*'};
    int K[10] = {6,4,2,6,5,3,4,2,1,1};
    char p = 'b';
    int br_poteza = JedanCiklus(A,K,n,nK,&p);

    if(br_poteza == -1)
        printf("Nema pobjednika u %d poteza.", nK);
    else
        printf("U %d poteza pobijedio je %c.", br_poteza, p);

    return 0;
}
