#include<stdio.h>

/* (a) podzadatak */
int  binomni(int n, int k){
    int rez = 1, i;
    /* koristimo: n povrh k jednako je
         (n * (n-1) * ... * (n-k+1)) / k! */
    for(i = n; i >= n - k + 1; --i)
        rez *= i;
    for(i = 1; i <= k; ++i)
        rez /= i;
    return rez;
}

/* (b) podazadatak */
int jel_prost(int br){
    if(br == 1)
        return 0;
    int i;
    for(i = 2; i < br; ++i)
        if(br % i == 0)
            return 0;
    return 1;
}

int Catalan(int n, int *broj){
    int cat = binomni(2 * n, n) / (n + 1);
    *broj = 0;

    int i;
    for(i = 1; i <= cat; ++i)
        if(cat % i == 0 && jel_prost(i) == 1)
            (*broj)++;

    return cat;
}


/* (c) podazadatak */

/* primjer: za m = 50 i n = 100 nema takvih brojeva,
   dok za m = 100 i n = 500, trazeni brojevi su 132 i 429 */

int main(void){
    int m, n;
    printf("Unesite m: ");
    scanf("%d", &m);
    printf("Unesite n: ");
    scanf("%d", &n);

    int bilo_ispisa = 0;

    int i = 1, broj, cat;

    do{
        cat = Catalan(i, &broj);
        if(cat > m && cat <= n && broj >= 3){
            printf("%d\n", cat);
            bilo_ispisa = 1;
        }
        i++;
    }while(cat <= n);

    if(bilo_ispisa == 0)
        printf("Nema takvih brojeva.");

    return 0;
}
